<template>
  <div class="box p-5 md:p-8 mb-10">
    <form @submit.prevent="form.post('/form/raisedForm', { preserveScroll: true })" autocomplete="off">
      <h3>Create Raised Form</h3>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full">
              <label for="department-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                Raised Form Name</label>
              <input id="name" class="input w-full" type="text" placeholder="Enter raised form name name"
                v-model="form.name" />
              <div v-if="form.errors.name" class="text-error">
                {{ form.errors.name }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700">
          Form Template (Form templates cannot be changed once this is created)</label>
        <multiselect v-model="form.form_template" :multiple="false" :options="formTemplates" label="name" track-by="id"
          :customLabel="(formTemplate) => `${formTemplate.name}`">
        </multiselect>
        <div v-if="form.errors.form_template" class="text-error">
          {{ form.errors.form_template }}
        </div>
      </div>

      <div class=" mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700">
          Subjects (This cannot be changed once this is created)</label>
        <div class="flex flex-col md:flex-row gap-2 mb-2">
          <div class="flex flex-1 gap-1">
            <select v-model="role" class="dropdown flex-1">
              <option :value="role.id" v-for="role in roles">{{ role.name }}</option>
            </select>
            <button class="h-12 px-6 bg-green-600 text-white font-semibold rounded-lg shadow-md hover:bg-green-700 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-opacity-75 transition ease-in-out duration-150" type="button" @click="() => {
    users.forEach(user => {
        if (user.role.id === role && !form.users.find((u) => user.id === u.id)) {
            form.users.push(user);
        }
    });
}">
    Insert
</button>

          </div>

          <div class=" flex flex-1 gap-1">
            <select v-model="department" class="dropdown flex-1">
              <option :value="department.id" v-for="department in departments">{{ department.name }}</option>
            </select>
            <button class="h-12 px-6 bg-green-600 text-white font-semibold rounded-lg shadow-md hover:bg-green-700 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-opacity-75 transition ease-in-out duration-150" type="button" @click="() => {
              users.forEach(user => {
                if (user.department_staff_detail && user.department_staff_detail.department_id === department && !form.users.find((u) => user.id === u.id)) {
                  form.users.push(user);
                }
              });
            }">
              Insert
            </button>
          </div>

          <button button class=" h-12 px-6 bg-gray-200 text-gray-700 font-semibold rounded-lg shadow-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-200 focus:ring-opacity-75 transition ease-in-out duration-150" @click="form.users = []" type="button">
            Clear
          </button>
        </div>
        <multiselect v-model="form.users" :multiple="true" :options="users" label="name" track-by="id"
          :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
        </multiselect>
        <div v-if="form.errors.users" class="text-error">
          {{ form.errors.users }}
        </div>
        <div>
          <input v-model="form.self_fill_out" class="checkbox mr-2" type="checkbox">
          <span class="text-sm">Self fill out</span>
        </div>
        <label class="block mb-2 text-sm font-medium text-gray-700" :class="{'opacity-30' : form.self_fill_out}">
          Who can fill out this form? (This cannot be changed once this is created)</label>
        <multiselect v-model="form.form_filler" :multiple="false" :options="users" label="name" track-by="id"
          :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`" :disabled="form.self_fill_out">
        </multiselect>
      </div>

      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700 ">
          Who should be notified when this form is filled out? (This cannot be changed once this is created)</label>
        <multiselect v-model="form.notification_subjects" :multiple="true" :options="users" label="name" track-by="id"
          :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
        </multiselect>
        <div v-if="form.errors.users" class="text-error">
          {{ form.errors.users }}
        </div>
      </div>

      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700 ">
          Who can approve the forms? (Define stages for each approver. This cannot be changed once
          this is created)</label>
        <multiselect v-model="approvers" :multiple="true" :options="users" label="name" track-by="id"
          :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
        </multiselect>
        <div v-if="form.errors.approvers" class="text-error">
          {{ form.errors.approvers }}
        </div>

        <div class="mt-3">
          <div v-for="(approver, index) in form.approvers" class="mb-4">
            <Icon icon="fa-solid fa-user" class="text-base mr-2"></Icon>
            <label class="text-sm font-semibold">
              {{ approver.user.name }} ({{ approver.user.role.name }}) - CID {{ approver.user.cid }}
            </label>
            <div class="w-full flex gap-x-3 items-center">
              <div class="text-sm font-orange-500">
                Stage
              </div>
              <input v-model="form.approvers[index].stage" class="flex-1 input" placeholder="Enter approval stage"
                type="number" min="1">
            </div>

            <div v-if="form.errors[`${approver.user.id}id`]" class="text-error">
              {{ form.errors[`${approver.user.id}id`] }}
            </div>
          </div>
        </div>
      </div>

      <div class="flex gap-x-3 mt-3 flex-row-reverse">
        <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
    <Link href="/form/raisedForm" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
      </div>
    </form>
  </div>
</template>

<script setup>
import { Link, useForm } from '@inertiajs/vue3';
import { ref, watch } from 'vue';

const props = defineProps({
  formTemplates: Array,
  users: Array,
  roles: Array,
  departments: Array
})

const role = ref(props.roles[0].id);
const department = ref(props.departments[0].id);

const approvers = ref([]);

const form = useForm({
  name: '',
  self_fill_out: true,
  notification_subjects: [],
  users: [],
  approvers: [],
  form_template: null,
  form_filler: null
});

watch(approvers, (value) => {
  var oldApprovers = form.approvers;
  form.approvers = [];

  value.forEach((approver) => {
    var result = oldApprovers.find((oldApprover) => oldApprover.user.id === approver.id)
    if (result) {
      form.approvers.push({ user: approver, stage: result.stage })
    } else {
      form.approvers.push({ user: approver, stage: null })
    }
  })
})
</script>